package liferay.intranet.dao;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.hibernate.Hibernate;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import liferay.intranet.domain.App;
import liferay.intranet.domain.Group;
import liferay.intranet.domain.User;


@Repository //indica que s una classe relacionada en la capa de persitncia i usa patr Singleton
public class AppDAOImpl implements AppDAO {
	@Autowired //s'encarrega de cercar un bean de la classe corresponent
	private SessionFactory sessionFactory;
	
	public void addApp(App app) {
		sessionFactory.getCurrentSession().save(app);
	}
	
	public List<App> listApps() {

		return sessionFactory.getCurrentSession().createQuery("FROM App").list();
	}
	
	public List<Group> listGroups() {

		return sessionFactory.getCurrentSession().createQuery("FROM Group").list();
	}
	
	//elimna una aplicaci de la bd
	public void removeApp(Integer id_dispositiu) {
		App app = (App) sessionFactory.getCurrentSession().load(
				App.class, id_dispositiu);
		if (null != app) {
			sessionFactory.getCurrentSession().delete(app);
		}

	}
	//busca a la base de dades una aplicaci concreta i retorna l'apliaci
	public App findApp(Integer id) {
		
		App app = (App) sessionFactory.getCurrentSession().load(App.class, id);
	
		Hibernate.initialize(app.getDescripcio());

		return app;
	}
	
	//modifica l'aplicaci passada per parmetre a la base de dades
	public void editApp(App consultapp) {
	
		sessionFactory.getCurrentSession().update(consultapp);
		
	}
	
	//retorna un boole indicant si s adminsitrador o no l'usuari passat per parmetre
	public boolean isAdmin(Integer idUser) {
		boolean admin = false;
		
		//fem consulta buscant tots els grups disponibles per a un usuari concret
		Query query = sessionFactory.getCurrentSession().createQuery("from User where userid = :idUser ");
		query.setParameter("idUser", idUser);
		List list = query.list();
		
		User u = (User)list.get(0);
		Set<Group> listGroups = u.getGroups();
		
		Iterator<Group> it1 = listGroups.iterator();
        while (it1.hasNext()){
            Group tmp = it1.next();
            //comprovem si aquest usuari s l'administrador
            if (tmp.getName().equals("groupadmin")){
            	admin = true;
            }      
        } 
		
		return admin;
	}
	
	//retorna una llista d'aplicacions que pertanyen a un usuari concret
	public List<App> displayApps(Integer idUser) {
		List<App> apps = new ArrayList<App>();
		//fem consulta buscant tots els grups disponibles per a un usuari concret
		Query query = sessionFactory.getCurrentSession().createQuery("from User where userid = :idUser ");
		query.setParameter("idUser", idUser);
		List<User> list = query.list();
		
		User u = (User)list.get(0);

		Set<Group> listGroups = u.getGroups();

		Iterator<Group> it1 = listGroups.iterator();
        while (it1.hasNext()){
            Group tmp = it1.next();
            //si aquest grup t aplicacions asignades l'afegim a la taula d'aplicacions per a mostrar
            if (tmp.getApp()!=null){
            	apps.add(tmp.getApp());
            }
        } 
		
		return apps;
	}
	
	
}
