package liferay.intranet.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;
import org.hibernate.annotations.Type;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.commons.CommonsMultipartFile;

import javax.persistence.Entity;


@Entity //defeix la classe com una entitat
@Table(name="APPS")//nom de la taula a la base de dades
public class App implements Serializable {
	@Id //clau primria
	@Column(name="ID_APP") //nom de l'atribut
	@GeneratedValue//valor autonumric
	private Integer id_app;
	
	@Column(name="NOM")
	private String nom;

	@Column(name="DESCRIPCIO")
	private String descripcio;

	@Column(name="URL")
	private String url;
	
	@Column(name="OBSERVACIONS")
	private String observacions;
	
	@Column(name="NOMICON")
	private String nomIcon;

	@Column(name="USERGROUPID")
	private Integer usergroupid;
	
	@Column(name="ICON")
    @Lob
    CommonsMultipartFile icon;
	
	@Type(type="yes_no")
	private boolean actiu;
	
	@OneToOne	//relaci 1a1 entre una aplicaci i un grup
	@JoinColumn(name = "USERGROUPID", insertable=false, updatable=false)
	private Group mgroup;
	

	public Integer getId_app() {
		return id_app;
	}

	public void setId_app(Integer id_app) {
		this.id_app = id_app;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getDescripcio() {
		return descripcio;
	}
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	
	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}
	

	public String getNomIcon() {
		return nomIcon;
	}

	public void setNomIcon(String nomIcon) {
		this.nomIcon = nomIcon;
	}
	
	public String getObservacions() {
		return observacions;
	}

	public void setObservacions(String observacions) {
		this.observacions = observacions;
	}
	

	public Integer getUsergroupid() {
		return usergroupid;
	}

	public void setUsergroupid(Integer usergroupid) {
		this.usergroupid = usergroupid;
	}

	public CommonsMultipartFile getIcon() {
		return icon;
	}

	public void setIcon(CommonsMultipartFile icon) {
		this.icon = icon;
		
		
	}

	public boolean isActiu() {
		return actiu;
	}

	public void setActiu(boolean actiu) {
		this.actiu = actiu;
	}
	
	
	public Group getMgroup() {
		return mgroup;
	}

	public void setMgroup(Group mgroup) {
		this.mgroup = mgroup;
	}

}
	

	

	
