package liferay.intranet.domain;


import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.ManyToMany;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;
import org.hibernate.annotations.Type;

import javax.persistence.Entity;


@Entity//defeix la classe com una entitat
@Table(name="USERGROUP")//nom de la taula a la base de dades


public class Group implements Serializable {
	@Id//clau primria
	@Column(name="USERGROUPID")//nom de l'atribut
	@GeneratedValue//valor autonumric
	private Integer userGroupId;
	
	@Column(name="NAME")
	private String name;


	//relacio NtoM de Users i groups, es fa el joina de la taula USERS_USERSGROUPS la qual cont les relacions entre usuaris i grups
	@ManyToMany(cascade = CascadeType.ALL)
    @JoinTable(
            name = "USERS_USERGROUPS",
            joinColumns = @JoinColumn(name = "USERGROUPID"),
            inverseJoinColumns = @JoinColumn(name = "USERID")
    )
	private Set<User> users = new HashSet<User>();

	//relaci 1a1 entre group i app, mapegem l'objecte
	@OneToOne(mappedBy = "mgroup")
	private App mapp;

	
	
	public Integer getUserGroupId() {
		return userGroupId;
	}

	public void setUserGroupId(Integer userGroupId) {
		this.userGroupId = userGroupId;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public Set<User> getUsers() {
		return users;
	}

	public void setUsers(Set<User> users) {
		this.users = users;
	}
	
	public App getApp() {
		return mapp;
	}

	public void setApp(App mapp) {
		this.mapp = mapp;
	}


}
	

	

	
