package liferay.intranet.service;




import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import liferay.intranet.dao.AppDAO;
import liferay.intranet.domain.App;
import liferay.intranet.domain.Group;

@Service //s'especifica que aquesta classe contindr la lgica de negoci
public class AppServiceImpl implements AppService {
	@Autowired //s'encarrega de cercar un bean de la classe corresponent 
	private AppDAO appDAO;
	
	@Transactional //s'especifica quins mtodes vols que s'executen en una sola transacci
	public boolean isAdmin(Integer idUser){
		return appDAO.isAdmin(idUser);
	}
	
	@Transactional
	public void addApp(App app) {
		appDAO.addApp(app);
	}

	@Transactional
	public List<App> listApps() {

		return appDAO.listApps();
	}
	
	@Transactional
	public List<Group> listGroups() {

		return appDAO.listGroups();
	}
	

	@Transactional
	public void removeApp(Integer id_dispositiu) {
		//System.out.println("2");
		appDAO.removeApp(id_dispositiu);
		
	}
	//
	@Transactional
	public App consultApp(Integer id){
		
		App p = (App) appDAO.findApp(id);
		//System.out.println("services::"+p.getMarca());
		
		return p;
	}
	@Transactional
	public void editApp(App consultapp) {
		//System.out.println("update services::"+consultapp.getMarca());
		appDAO.editApp(consultapp);
		
	}
	
	@Transactional
	public List<App> displayApps(Integer idUser) {

		return appDAO.displayApps(idUser);
	}
	
}
